	include "doorsos.h"
	xdef	_library
	xdef    _ti89
	xdef    _ti92plus
	xdef	userlib@0000	;idle_loop
	xdef	userlib@0001	;random
	xdef	userlib@0002	;rand_seed
	xdef	userlib@0003	;exec
	xdef	userlib@0004	;FindSymEntry
	xdef	userlib@0005	;DrawCharXY


userlib@0000:
idle_loop:
	movem.l	a0-a6/d1-d7,-(a7)
\idle_start
	move.l	APD_INIT,APD_TIMER   ; reset APD timer
	clr.w	APD_FLAG		; reset APD flag
\wait_idle
	tst.w	APD_FLAG		; time for APD?
	beq	\no_apd			; no -- do not shut down
\do_apd
	trap	#4
	bra	\idle_start
\no_apd
	tst.w	(doorsos::kb_vars+$1C)     ; has a key been pressed?
	beq	\wait_idle
	move.l	APD_INIT,APD_TIMER   ; reset APD timer (1)
	move.w	(doorsos::MaxHandles+$1E),d0
	clr.w	(doorsos::kb_vars+$1C)     ; clear key buffer
\try_key_off
	cmp.w	#KEY_DIAMOND+$10B,d0		;press of diamond+On
	beq	\do_apd			;->off
\not_key_off
	movem.l	(a7)+,a0-a6/d1-d7
	rts


userlib@0001:
random:
	move.l	d1,-(sp)
	move.w	rand_seed(pc),d1
	mulu.w	#31421,d1
	add.w	#6927,d1
	mulu.w	d1,d0
	move.w	d1,rand_seed
	clr.w	d0
	swap	d0
	move.l	(sp)+,d1
	rts
        
userlib@0002:
rand_seed	dc.w	0

userlib::exec
userlib@0003:
        move.w 4(a7),d0
        DEREF d0,a0
        move.w (a0),d1
	lea	1(a0,d1.w),a2
	cmp.b	#$F3,(a2)
	bne	\Fail

        cmp.l #$200000,a0
        blt \notarchived
        clr.l d0
	move.w	(a0),d0
        addq.l #3,d0
        move.l a0,-(a7)
        move.l d0,-(a7)
        jsr doorsos::HeapAlloc	;allocates a block to copy from Archive memory
        move.l (a7)+,d1
        move.l (a7)+,a1

        tst.w d0
        beq \Fail

        move.w d0,-(a7)
        DEREF d0,a0
        move.l a0,-(a7)
        subq.l #1,d1
\cpy
        move.b (a1)+,(a0)+
        dbra d1,\cpy
        move.l (a7)+,a0
        bra \rel
\notarchived
        move.w #0,-(a7)
\rel
        move.l a0,a5
        addq.l #2,a5

        move.w (a0),d1
	lea	1(a0,d1.w),a0

\rloop
        move.w -(a0),d0
        tst.w d0
        beq \endr
        clr.l d1
        move.w -(a0),d1
        add.l a5,d1
        move.l d1,0(a5,d0.w)
        bra \rloop
\endr
        jsr (a5)

        move.w (a7)+,d1
        tst.w d1
        beq \Fail
        move.l d0,-(a7)
        move.w d1,-(a7)
        jsr doorsos::HeapFree
        add.l #2,a7
        move.l (a7)+,d0
\Fail	rts

userlib@0004:

FindSymEntry:
;parameters are pushed in the stack in that order
;1 : adress to the name of the symbol to look for
;2 : handle of the list you look in

	movem.l	d0-d7/a1-a6,-(a7)
	move.l	62(a7),a1
	move.w	60(a7),d0

        move.l  doorsos::Heap,a0
	lsl.w	#2,d0
	move.l	0(a0,d0.w),a0
	addq.l	#2,a0
	move.w	(a0)+,d5
	subq.w	#1,d5	;for dbra

\search movem.l	a0/a1,-(a7)
	jsr		doorsos::strcmp
	movem.l	(a7)+,a0/a1
	tst.w		d0
	beq		\end
	lea		14(a0),a0
	dbra		d5,\search
	sub.l		a0,a0
\end	movem.l (a7)+,d0-d7/a1-a6
	rts

userlib@0005
DrawCharXY
	move.w	4(a7),d0
	lea	char(pc),a0
	move.b	d0,char
	move.w	10(a7),-(a7)
	move.l	a0,-(a7)
	move.w	14(a7),-(a7)
	move.w	14(a7),-(a7)
	jsr	doorsos::DrawStrXY
	lea	10(a7),a7
	rts

char	dc.b	0,0

	end
