userlib::idle_loop      equ     userlib@0000
;------------------------------------------------------------
; Waits for a key input and returns the keycode value in d0
; Supports APD and shuts down if user presses <DIAMOND>+<ON>
;------------------------------------------------------------

userlib::random		equ	userlib@0001
;----------------------------------------------------------------------------
; random(void)
;
; Function: Return a pseudorandom number
;
; input:  D0.W = upper limit
; output: D0.W = random number in [0..limit-1]
;----------------------------------------------------------------------------

userlib::rand_seed	equ	userlib@0002
;----------------------------------------------------------------------------
; WORD rand_seed
;
; Random seed used by random(). You may store values to it to initialize
; the random number seed.
;----------------------------------------------------------------------------


userlib::exec		equ	userlib@0003
;----------------------------------------------------------------------------
;executes a program
;the parameter for this function is pushed on the stack
;input:	the handle of the program to execute
;output: d0.w = result
;
;Here are d0 values as result:
;0 -> everything is alright
;1 -> no mem
;2 -> lib not found
;3 -> wrong lib version
;4 -> file format is not valid
;other -> file was not a Doors OS file but was run.
;----------------------------------------------------------------------------

userlib::FindSymEntry	equ	userlib@0004
userlib::DrawCharXY	equ	userlib@0005
